Bug Hunting Session
Bug 103405 - L10n: Add additional user interface language Hungarian Rovas [hu-Hung-HU]
Summary: L10n: Add additional user interface language Hungarian Rovas [hu-Hung-HU]
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Installation (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
: 119767 120205 (view as bug list)
Depends on: 107204 113017 123219
Blocks: l10n-hu-Hung-HU 127722
  Show dependency treegraph
 
Reported: 2016-10-22 08:16 UTC by Óvári
Modified: 2019-09-23 16:29 UTC (History)
10 users (show)

See Also:
Crash report or crash signature:


Attachments
Installation Additional user interface languages.png (22.17 KB, image/png)
2016-10-22 08:17 UTC, Óvári
Details
Installation Additional user interface Serbian.png (18.74 KB, image/png)
2016-10-22 08:18 UTC, Óvári
Details
Installation Additional user interface Hungarian.png (19.39 KB, image/png)
2016-10-22 08:18 UTC, Óvári
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Óvári 2016-10-22 08:16:43 UTC
Description:
In LibreOffice installation, section ‘Additional user interface languages’ (see attachment: Installation Additional user interface languages.png), add:
    Hungarian (Rovas)

The current ‘Hungarian’ could be modelled on Serbian (see attachment: Installation Additional user interface Serbian.png):
Serbian (Cyrillic)
Serbian (Latin)

Suggestions to the installation ‘additional user interface language’ option:
1. Rename the current entry in the language list entitled ‘Hungarian’ (see attachment: Installation Additional user interface Hungarian.png) to ‘Hungarian (Latin)’ [Could this please be done before the 5.3.0 string freeze?]
2. Add ‘Hungarian (Rovas)’ to the language list

Thank you

LibreOfficeDev 5.3.0.0.alpha1
Windows 8.1

Steps to Reproduce:
See Description

Actual Results:  
See Description

Expected Results:
See Description


Reproducible: Always

User Profile Reset: No

Additional Info:


User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:49.0) Gecko/20100101 Firefox/49.0
Comment 1 Óvári 2016-10-22 08:17:39 UTC
Created attachment 128148 [details]
Installation Additional user interface languages.png
Comment 2 Óvári 2016-10-22 08:18:12 UTC
Created attachment 128149 [details]
Installation Additional user interface Serbian.png
Comment 3 Óvári 2016-10-22 08:18:43 UTC
Created attachment 128150 [details]
Installation Additional user interface Hungarian.png
Comment 4 RovasFoundation 2016-10-22 10:10:11 UTC
Dear All,

I support the idea of the language option separation with a slight modification.

As there are Latin and multiple! Rovas scripts for the Hungarian language (even Cyrillic was created), my suggestion is the following:

Hungarian (Latin)
Hungarian (Rovas-SH)

* The SH index stands for Szekely-Hungarian, the mostly used member of the Rovas script family.

Please note, that there are more distinct Rovas scripts (not versions or font variations) as well for the Hungarian language (and occasionally used for other languages too). Most of them are extinct but for example the Carpathian Basin Rovas is revitalized with a possibly growing user base in the future.

Do not worry :) at this moment, it is not the goal to deal with any other member of the Rovas script family. The reason I draw your attention - and suggest the SH index - to suit the terminology for possible future extension.

Rgds, László

> Suggestions to the installation ‘additional user interface language’ option:
> 1. Rename the current entry in the language list entitled ‘Hungarian’ (see
> attachment: Installation Additional user interface Hungarian.png) to
> ‘Hungarian (Latin)’ [Could this please be done before the 5.3.0 string
> freeze?]
> 2. Add ‘Hungarian (Rovas)’ to the language list
Comment 5 Joel Madero 2016-10-23 19:49:06 UTC
The real issue isn't adding the option to the list but doing all the behind the scenes work that comes with it (such as currency, spell check, etc....) Is there a LibreOffice community who would actively support this?
Comment 6 V Stuart Foote 2017-07-28 15:40:21 UTC
Not sure why this enhancement was not set NEW. Doing so.
Comment 7 Kovács Viktor 2018-09-12 18:14:35 UTC
(In reply to Joel Madero from comment #5)
> The real issue isn't adding the option to the list but doing all the behind
> the scenes work that comes with it (such as currency, spell check, etc....)
> Is there a LibreOffice community who would actively support this?
@Joel:I found a developer on the MS' ideas page , who created a spelling checker for Old Hungarian script, but she developed it for her own MS Office. (She was angry about that, MS cleared her work)I dont know, how could be invited, just her name is known. What did you mean about currency? Old Hungarian script uses runic like numbers.
Comment 8 Andras Timar 2018-09-12 19:46:56 UTC
(In reply to Kovács Viktor from comment #7)
First you need to make transliteration existing Hungarian translation to Rovas script for UI and help. I can imagine that proofreading of this would be a lot of work. Then it is a no-brainer to add another line to installer, and offer Hungarian (Rovas) for the users. 

For the spell checker, I don't think we can use anything made for MS Office. We need a dictionary and affix file in Hunspell format. Probably this could be based on existing Hungarian spelling dictionary and affix file.

For the locale data, again, you need to transliterate existing hu_HU locale data, currency is HUF of course, providing that most users of this "locale" would be in Hungary. But that's not a top priority I think. I suggest you move step by step. If you want Rovas UI, go for that first. The LibreOffice community is happy to help with integration of your work.
Comment 9 Kovács Viktor 2018-09-13 05:47:49 UTC
*** Bug 119767 has been marked as a duplicate of this bug. ***
Comment 10 Kovács Viktor 2018-09-15 09:07:33 UTC
(In reply to Andras Timar from comment #8)
Ok. I develop hunspell for Hungarian Rovás, but there are several problem: I developed Old Hungarian script for DejaVu. (See https://bugs.freedesktop.org/show_bug.cgi?id=107496 ) I had done several mistakes on Github, thoose I resolved, and added #28 pull request. It isn't accepted yet. I dont know, which font family uses the LibreOffice for UI, or it could be setting hardly as default UI font.
Hunspell: I have problems with it. I don't know the full syntax of .aff files on github, and how could I translate it.
Are there any strict syntax of UI description?
Comment 11 V Stuart Foote 2018-09-15 13:24:54 UTC
The supporting font work for inclusion in Dejavu Sans as suggested to Viktor, by László, is here: 

https://github.com/dejavu-fonts/dejavu-fonts/pull/28

https://bugs.freedesktop.org/show_bug.cgi?id=107496

As to the tranliteration of the UI to Rovas, or implementation of a a Hunspell module for Rovas that was described by Tamas R. in cmnt #28 of bug 97406

Hunspell is of course László's baby...
Comment 12 Kovács Viktor 2018-09-18 12:02:06 UTC
(In reply to V Stuart Foote from comment #11)
> Hunspell is of course László's baby...
I need to discuss about László in private mailing. It's not an easy way to create spelling dictionary for Hungarian Rovás. Not just a mirroring method. There are difficult rules. I don't think, discuss in the bug is enough.
Comment 13 Kovács Viktor 2018-09-19 03:25:58 UTC
László, could we communicate about hunspell for rovás in private e-mail's?
Comment 14 Kovács Viktor 2018-09-28 18:52:37 UTC
There is a language ID: hu-Hung-HU. There is an UNICODE code page called "Old Hungarian". The LibreOffice can use this page as RTL script, named "none". Could  any programmer to link this two things?
Comment 15 Kovács Viktor 2018-09-29 17:52:20 UTC
cc:Khaled,
I remember, you were, who coded the "Old Hungarian" part of UNICODE range RTL capability, with language name as "none". I didn't know, that it has identifier, ISO639 ID is ohu, and has already a BCP 47 script subtag, too.
ID hu-HUng-HU is derived from BCP 47 ID and Hungarian ID hu. The UNICODE range U+10C80-10cff must to be linked a meta tag "hu-Hung-HU", thats are the same things.
Could you code the link between "hu-Hung-HU" and "Old Hungarian" RTL capatibility?
Comment 16 V Stuart Foote 2018-09-30 16:35:17 UTC
*** Bug 120205 has been marked as a duplicate of this bug. ***
Comment 17 Eike Rathke 2018-10-02 13:26:24 UTC
Are 'hu-Hung' and 'ohu' synonyms, and 'ohu' (Old Hungarian) has implicit 'Hung' (Hungarian Runic) script? Or wouldn't it rather have to be an explicit 'ohu-Hung'? The IANA language tag registration doesn't mention Suppress-Script: Hung, so it would have to be 'ohu-Hung'.

Is 'ohu-Hung' to be preferred over 'hu-Hung'?
Comment 18 Kovács Viktor 2018-10-10 12:05:48 UTC
(In reply to Eike Rathke from comment #17)
> Are 'hu-Hung' and 'ohu' synonyms, and 'ohu' (Old Hungarian) has implicit
> 'Hung' (Hungarian Runic) script? Or wouldn't it rather have to be an
> explicit 'ohu-Hung'? The IANA language tag registration doesn't mention
> Suppress-Script: Hung, so it would have to be 'ohu-Hung'.
> 
> Is 'ohu-Hung' to be preferred over 'hu-Hung'?

I asked ISO639-3 standard registar about Old Hungarian IDs.
I got an answer from the op. Doug Ewell. He wrote:

There is already a BCP 47 script subtag for the Old Hungarian (rovásírás)  script, 'Hung'. There is also a language subtag for the Old Hungarian language, 'ohu'.
These subtags can be combined to create a full BCP 47 language tag, such as "hu-Hung" for "modern Hungarian written in the Old Hungarian script."
 
I didn't use word "rovásírás" in my question.
Comment 19 Eike Rathke 2018-10-10 15:58:13 UTC
Thanks. I take it that the current 'hu-Hung' actually is what is wanted, "modern Hungarian written in the Old Hungarian script".
Comment 20 Kovács Viktor 2018-12-25 09:58:31 UTC
(In reply to Eike Rathke from comment #19)
> Thanks. I take it that the current 'hu-Hung' actually is what is wanted,
> "modern Hungarian written in the Old Hungarian script".

I asked op Doug Ewell again, he answered, hu-Hung-HU is only redundant.
My problem is not that redundant form. My problem is the following: hu-Hung-HU language id eists in the LibreOffice project. The LibreOffice have capability Right-to-left writing system for the Old Hungarian Unicode range,(since version 6.1 writer can do it, since version 6.2 can use it all components) but it is unnamed, (named as "none"). I would like that, these two things would be attached each other.
Comment 21 Kovács Viktor 2018-12-25 11:12:09 UTC
I am sorry, Writer has Rtl capability for that codepage since version 6.0, the others since version 6.1.
Comment 22 Kovács Viktor 2018-12-25 14:17:54 UTC
cc:V Stuart Foote
Please read Comment #20 and Comment #21.
May I file a new bug?
Comment 23 V Stuart Foote 2018-12-25 21:54:21 UTC
(In reply to Kovács Viktor from comment #22)
> cc:V Stuart Foote
> Please read Comment #20 and Comment #21.
> May I file a new bug?

IMHO I don't see a new issue as necessary (and which you'd done as bug 119767, duped back to this issue). 

hu-Hung is already handled as any other script that does not have a fully implemented interface.

When Hungarian (Szekely-Hungarian Rovas) is assigned as the default CTL script (with suitable font support) use of glyphs in the Old Hungarian (10c80-10cff) will pickup the appropriate language assignment.

It has little affect otherwise as the issues here it requires an additional user interface with spellcheck and UI that remain to be implemented. Otherwise the hu-Hung language is assigned, the same as other scripts with no more than language code assignment.
Comment 24 Kovács Viktor 2018-12-26 09:34:12 UTC
(In reply to V Stuart Foote from comment #23)
> When Hungarian (Szekely-Hungarian Rovas) is assigned as the default CTL
> script (with suitable font support) use of glyphs in the Old Hungarian
> (10c80-10cff) will pickup the appropriate language assignment.
> 
> It has little affect otherwise as the issues here it requires an additional
> user interface with spellcheck and UI that remain to be implemented.
> Otherwise the hu-Hung language is assigned, the same as other scripts with
> no more than language code assignment.

Thank you for the informations.
As you know, there is a patch for DejaVu-fonts, but on the github is only 3rd between the opened pull request. 
I promissed, that I would make the spellchecker, but it doesn't work unless extend the hunspell binary, I think. I am working on. (I couldn't work for two months, unfortunately.) 

About the fonts: we discussed several months (or a year) ago, that I could make a special Old Hungarian font (compatible with Unicode). It would be quicklier.
Should we go back to that point? It's already made, I need to make only a project page.
Comment 25 Kovács Viktor 2019-01-16 09:03:48 UTC
cc:László Németh
Spellchecker of "Székely-magyar rovás" will not work without changing the binary of hunspell. 

First main problem is that, client or "user-program" asks whether the character is letter or not. The answer with the Old Hungarian characters always "No". 

In that case the user-program will not run the spellchecker method, and ICONV/OCONV macros (you suggested it) will not work at all.

I got some idea, but we need work on the binary together, I think.

Thanks.
Comment 26 Kovács Viktor 2019-02-03 13:05:45 UTC
(In reply to Kovács Viktor from comment #25)
> cc:László Németh
> Spellchecker of "Székely-magyar rovás" will not work without changing the
> binary of hunspell. 
> 
> First main problem is that, client or "user-program" asks whether the
> character is letter or not. The answer with the Old Hungarian characters
> always "No". 
> 
> In that case the user-program will not run the spellchecker method, and
> ICONV/OCONV macros (you suggested it) will not work at all.
> 
> I got some idea, but we need work on the binary together, I think.
> 
> Thanks.

We talked about it, László Németh give me instructions, how could works without changing the binary.
Comment 27 Kovács Viktor 2019-02-03 13:15:20 UTC
cc:V Stuart Foote
> (In reply to V Stuart Foote from comment #23)
> > When Hungarian (Szekely-Hungarian Rovas) is assigned as the default CTL
> > script (with suitable font support) use of glyphs in the Old Hungarian
> > (10c80-10cff) will pickup the appropriate language assignment.
There is a project with suitable Old hungarian font as defined in UNICODE standard, it have required punctuation and quotation marks, as we had talked about it before.
project page: https://github.com/kende-fonts/kende-fonts/
Github.io page: https://kende-fonts.github.io/kende-fonts/
May I file a bug to accept It?
Comment 28 Tamas Rumi 2019-02-03 13:42:03 UTC
It is crucial to mention, that the Unicode standard is incomplete, there are no punctuation marks, and there are no codepoints for several letters. However if we want the LO a perfect platform for the rovas script users, these missing characters are required for fonts of LO. The solution is, that we could use the empty slots of the Old Hungarian rovas block to represent the missing characters. 

My colleagues support the idea to extend the character set with punctuation marks and missing characters by providing vector graphics for all letters. 

Tamas Rumi
Comment 29 Tamas Rumi 2019-02-03 15:47:06 UTC
We have been waiting to give assistance to LO community and developers:
font, spellchecker, UI.

1. We can provide full character set (vector graphics) for the rovas script, however, there are missing (Unicode) code points which still causes problems. Since we have been producing books entirely written in rovas script, so we have experience in font design.  

2. Moreover, about the rovas hunspell: we have a transcription solution for a large amount of text used to produce the abovementioned books. I hope we can support the LO developers in order to create a rovas spellchecker method.

3. As we promised, the LO UI localization also can be achieved, if the font question is solved. 

Tamas Rumi
Comment 30 Tamas Rumi 2019-02-03 17:44:43 UTC
(In reply to Óvári from comment #0)
> Description:
> In LibreOffice installation, section ‘Additional user interface languages’
> (see attachment: Installation Additional user interface languages.png), add:
>     Hungarian (Rovas)
> 
> The current ‘Hungarian’ could be modelled on Serbian (see attachment:
> Installation Additional user interface Serbian.png):
> Serbian (Cyrillic)
> Serbian (Latin)
> 
> Suggestions to the installation ‘additional user interface language’ option:
> 1. Rename the current entry in the language list entitled ‘Hungarian’ (see
> attachment: Installation Additional user interface Hungarian.png) to
> ‘Hungarian (Latin)’ [Could this please be done before the 5.3.0 string
> freeze?]
> 2. Add ‘Hungarian (Rovas)’ to the language list
> 

Dear Mr Óvári,
Please explain to me, why your suggested idea has not been implemented yet? I can not find the Hungarian Rovas in the language list.
Comment 31 Kovács Viktor 2019-02-04 16:43:55 UTC
cc:V Stuart Foote
So, may I file a bug for a font-acceptation method kende-fonts or any other well-done fonts, or we must to wait for a long period until DejaVu patch is accepted?
Comment 32 Kovács Viktor 2019-02-04 16:49:38 UTC
cc:Óvári
What is Your opinion about file a bug for a font acceptation method?
Comment 33 Óvári 2019-02-04 21:45:10 UTC
(In reply to Kovács Viktor from comment #32)
> cc:Óvári
> What is Your opinion about file a bug for a font acceptation method?

Can a developer who can accept changes please advise whether this will be accepted? Thank you
Comment 34 Kovács Viktor 2019-02-05 06:49:59 UTC
(In reply to Óvári from comment #33)
> (In reply to Kovács Viktor from comment #32)
> > cc:Óvári
> > What is Your opinion about file a bug for a font acceptation method?
> 
> Can a developer who can accept changes please advise whether this will be
> accepted? Thank you

Previously Stuart started with an e-mail, at already closed bug #113017 .
I asked you about Your opinion only.